// mode: -*- C++ -*-
#ifndef CONFIG_H
#define CONFIG_H

//#include "SDL_types.h"
//#include "SDL_video.h"
//#include "SDL_keysym.h"
#include "renderer.h"
#include <string>
#include "common.h"

namespace {
    const Uint8 NUMBINDABLE = 3;
}

enum KEY_TYPE {
    KEY_SIDEBAR = 0, KEY_STOP, KEY_ALLY
};

struct ConfigType
{
	Uint32	videoflags,
			startMoney;

	Uint16	width,
			height,
			bpp,
			serverport;

	Uint8		intro,
			gamemode,
			totalplayers,
			playernum,
			scrollstep,
			scrolltime,
			maxscroll,
			finaldelay,
			dispatch_mode;

	bool		nosound,
			pause,
			quit_mission,
			playvqa,
			allowsandbagging,
			debug,
			demo,
			UseFogOfWar,
			use_opengl;		// Enable/disable the fog of war

	gametypes	gamenum;

	SDL_GrabMode	grabmode;

	SDLKey		bindablekeys[NUMBINDABLE];

	Uint8		bindablemods[NUMBINDABLE];

	Uint8		buildable_radius;

	std::string	mapname,
			vqamovie,
			nick,
			side_colour,
			mside,		// side of human player
			cside,		// side of computer player
			serveraddr,	// ,disp_logname;
			binpath;	// vfs binpath
	double		buildable_ratio;


	// Some sounds
	char		// Structures
			*StructureDestroyed,
			*StructureHalfDestroyed,
			*StructureSold,
			*StructurePlaced,
			*StructureStartBuild,
			*StructureReady,
			*RepairStructure,
			*PrimairyStructureSelected,
			// Base
			*CmdCentreUnderAttack,
			*BaseUnderAttack,
			// Unit
			*UnitFull,
			*UnitLost,
			*RepairUnit,
			*UnitRepaired,
			*UnitSold,
			*UnitReady,
			*UnitDeployed,
			*TrainUnit,
			*AirUnitLost,
			// Naval
			*NavalUnitLost,
			// General
			*BattleControlTerm,
			*BuildingCanceled,
			*BuildingOnHold,
			*Newoptions,
			*NoDeploy,
			*NoFunds,
			*Nopower,
			*Reinforcements,
			*RadarUp,
			*RadarDown,
			*MissionWon,
			*MissionLost,
			// Money
			*MoneyCountUp,
			*MoneyCountDown;
};

//
//	this getConfig() is located in args.cpp
//
const ConfigType& getConfig();

#endif /* CONFIG_H */
